// Enkel fysisk modellering

// inn og ut
inlets = 1;
outlets = 2;

// Globale variabler
var tsk = new Task(mytask, this); 
var count = 0;
var decay = 1.0;

// argumenter
var dcoeff = -0.0002; 	// decay koeffisient
var note = 60; 			// note to trigger bounce

// tar inn argument-verdier
if(jsarguments.length>1)
{
	dcoeff = jsarguments[1];
}

function msg_int(a)
{
	note = a; 	
}

// Max-globale variabler
glob = new Global("bounce");
glob.starttime = 500;

////////////////////////////////////////

function bang()
{
	tsk.cancel();  	// avslutter bouncing hvis den er igang
	count = 0;  	// nullstiller bounce nummer
	decay = 1.0;	// tilbakestiller decay
	tsk.interval = glob.starttime;   // starttid til task
	tsk.repeat(); 	// starter bouncing
}

function stop()
{
	tsk.cancel();	// stopper metoden
}

function mytask()
{
	if(arguments.callee.task.interval>5) //  keep bouncing
	{
		outlet(0, note); 	// send ut noteverdi
		decay = decay*Math.exp(++count*dcoeff);  // regner ut decay
		arguments.callee.task.interval=arguments.callee.task.interval*decay;
	}
	else 	// kutter ut hvis vi nærmer oss bunnen
	{
		arguments.callee.task.cancel();	// avslutter
		outlet(1, bang);		// sender ut bang for å si at vi er ferdig
	}
}

mytask.local = 1;  	// for å unngå trigging direkte fra Max




